#include "stdafx.h"

#include "localanalyse.h"
//extern map<string, int> calls;

LocalAnalyse::LocalAnalyse(/*const*/ Distance *cd)
	: distance (cd)
{
}

double LocalAnalyse::blendmatch(int n, IScriptEnvironment *env) /*const*/
{/*++calls["LocalAnalyse::blendmatch"];*/
	if(n-1 < 0 || n+1 >= distance->frames())
		return 1.0;
	double dp	= distance->distance(n-1, n, env);
	double dn	= distance->distance(n, n+1, env);
	double dpn	= distance->distance(n-1, n+1, env);

	//use the cosine rule to find the cosine of the angle (previous-this-next) in question
	double c = (dp*dp + dn*dn - dpn*dpn)/(2*dp*dn);
	return c;
}

double LocalAnalyse::blendweight(int n, IScriptEnvironment *env) /*const*/
{
	if(n-1 < 0 || n+1 >= distance->frames())
		return 0.5;
	double dp	= distance->distance(n-1, n, env);
	double dn	= distance->distance(n, n+1, env);
	double dpn	= distance->distance(n-1, n+1, env);

	//use the cosine rule to find the cosine of the angle (this-previous-next) in question
	double c = (dp*dp + dpn*dpn - dn*dn)/(2*dp*dpn);
	double projection = c*dp;//projection of previous-this onto previous-next
	return projection/dpn;
}

double LocalAnalyse::duplicatematch(int n, IScriptEnvironment *env) /*const*/
{
	if(n-1 < 0 || n >= distance->frames())
		return 1000000.0;
	double dp = distance->distance(n-1, n, env);
	return dp;
}

int LocalAnalyse::frames() const
{
	return distance->frames();
}
