#include "stdafx.h"
#include "blend.h"


DisplacedVector<double> Composition::weight(int outframe, IScriptEnvironment *env) /*const*/
{
	DisplacedVector<double> weight2 = b2.weight(outframe, env);
	int resultstart = b1.weight(weight2.beginindex(), env).beginindex();
	int resultend =	b1.weight(weight2.endindex()-1, env).endindex();
	DisplacedVector<double> result(resultstart, resultend,0.0); 
	for (int i = weight2.beginindex(); i < weight2.endindex(); ++i)
	{
		DisplacedVector<double> weight1 = b1.weight(i, env);
		for (int j = weight1.beginindex(); j < weight1.endindex(); ++j)
			result.at(j) += weight2.at(i)*weight1.at(j);
	}
	return result;
}
/*
DisplacedVector<double> Resample::weight(int outframe, IScriptEnvironment *)const
{
	double exactstart = (phase + outframe) * fraction;
	double exactend = exactstart + fraction;
	int firstframe = floor(exactstart);
	int lastframe = ceiling(exactend)-1;//make sure e.g. end=3.000 counts as frame 2
	DisplacedVector<double> result(firstframe, lastframe+1);
	if (firstframe == lastframe)
	{
		result[firstframe] = 1;
	}
	else if (firstframe+1 == lastframe)
	{
		double lambda = (exactend - double(lastframe))/fraction;
		if (lambda!=(exactend - double(lastframe))/fraction) throw;
		result[firstframe] = 1-lambda;
		result[firstframe+1] = lambda;//
		result[firstframe] = (1-(exactstart-double(firstframe)))/fraction;
		for (int i=firstframe+1; i < lastframe; ++i)
			result[i] = 1.0/fraction;
		result[lastframe] = (exactend - double(lastframe))/fraction;
	}	
	//else 
	//	throw;
	return result;
}

DisplacedVector<double> ThresholdUpsample::weight(int outframe, IScriptEnvironment *) const
{
	double exactstart = (phase + outframe) * fraction;
	double exactend = exactstart + fraction;
	int firstframe = floor(exactstart);
	int lastframe = ceiling(exactend)-1;//make sure e.g. end=3.000 counts as frame 2
	if (firstframe == lastframe)
		return DisplacedVector<double> (firstframe, lastframe+1, 1.0);
	if (firstframe+1 == lastframe)
	{
		double lambda = (exactend - floor(exactend))/fraction;
		if (lambda<threshold)
			return DisplacedVector<double> (firstframe, firstframe+1, 1.0);
		if (lambda>1-threshold)
			return DisplacedVector<double> (firstframe+1, firstframe+2, 1.0);

		DisplacedVector<double> result(firstframe, firstframe+2);
		result[firstframe] = 1-lambda;
		result[firstframe+1] = lambda;
		return result;
	}	
	throw;
}

DisplacedVector<double> Telecine::weight(int outframe, IScriptEnvironment *) const
{
	const int pattern[5] = {0, 0, 1, 2, 3};
	int frame;
	if (outframe < skip)
		frame = outframe;
	else
	{
		int useframe = outframe - skip;
		frame = skip + 4*(useframe/5) + pattern[useframe%5];
	}
	return DisplacedVector<double> (frame, frame+1, 1.0);
}

DisplacedVector<double> Duplicate::weight(int outframe, IScriptEnvironment *) const
{
	int frame= outframe/2;
	return DisplacedVector<double> (frame, frame+1, 1.0);
}

DisplacedVector<double> Reblend::weight(int outframe, IScriptEnvironment *) const
{
	if (outframe == 0)
		return DisplacedVector<double> (0, 1, 1.0);
	DisplacedVector<double> result(outframe-1, outframe+2, 0.0);
	result[outframe-1] = 1-lambda;
	result[outframe+1] = lambda;
	return result;
}

DisplacedVector<double> TestBlend::weight(int outframe, IScriptEnvironment *) const
{
	int pattern= outframe%25;
	int frame = pattern + (outframe/25)*24;
	if (pattern == 0)
		return DisplacedVector<double> (frame, frame+1, 1.0);
	if (pattern >= 15)
		return DisplacedVector<double> (frame-1, frame, 1.0);

	double lambda = pattern/15.0;
	DisplacedVector<double> result(frame-1, frame+1);
	result[frame-1] = lambda;
	result[frame] = 1-lambda;
	return result;
}
//*/