#ifndef _WOVEN_H_
#define _WOVEN_H_

#include "blend.h"
#include "apply.h"


class Halve : public Blend
{
	int parity;
public:
	Halve(int _parity) : Blend (0.5), parity(_parity) {}
	virtual DisplacedVector<double> weight(int outframe, IScriptEnvironment *env) /*const*/;
};

class SelectParity : public GenericVideoFilter //local versions of selecteven, selectodd
{   
	int offset;
public:
	SelectParity(PClip _child, int _offset, IScriptEnvironment *env) : GenericVideoFilter(_child), offset(_offset) 
	{vi.num_frames = (vi.num_frames - offset)/2;}
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env) 
		{return child->GetFrame(2*n+offset, env);}
};

class ReverseHalfBlend : public GenericVideoFilter 
{   
	Blend *blend;
	int parity;
	Halve halve;
	Composition composite;
	PClip reversed;
public:
	ReverseHalfBlend(PClip _toreverse, Blend *_blend, int _parity, IScriptEnvironment *env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
};

class ReverseWovenBlend : public GenericVideoFilter //essentially an interleave
{   
	PClip evenpart;
	PClip oddpart;
public:
	ReverseWovenBlend(PClip toreverse, Blend *blend, IScriptEnvironment *env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
};

#endif