#include "localanalyse.h"

class WriteNumber : public GenericVideoFilter 
{   
public:
	WriteNumber(PClip _child, Number, const char *filename, IScriptEnvironment* env);
};
AVSValue __cdecl Create_WriteNumber(AVSValue args, void* user_data, IScriptEnvironment* env);



class And : public SelectFilter 
{   
	Select first, second;
public:
	And(PClip _child, Select _first, Select _second, IScriptEnvironment* env)
		: SelectFilter(_child, env), first(_first), second(_second){} 
	virtual SelectPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_And(AVSValue args, void* user_data, IScriptEnvironment* env);



class Or : public SelectFilter 
{   
	Select first, second;
public:
	Or(PClip _child, Select _first, Select _second, IScriptEnvironment* env)
		: SelectFilter(_child, env), first(_first), second(_second){} 
	virtual SelectPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_Or(AVSValue args, void* user_data, IScriptEnvironment* env);


class IsAbove : public SelectFilter 
{   
	double threshold;
	Number number;//(clip);
public:
	IsAbove(PClip _child, Number _number, double _threshold, IScriptEnvironment* env)
		: SelectFilter(_child, env), number(_number), threshold(_threshold){} 
	virtual SelectPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_IsAbove(AVSValue args, void* user_data, IScriptEnvironment* env);


class IsBelow : public SelectFilter 
{   
	double threshold;
	Number number;//(clip);
public:
	IsBelow(PClip _child, Number _number, double _threshold, IScriptEnvironment* env)
		: SelectFilter(_child, env), number(_number), threshold(_threshold){} 
	virtual SelectPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_IsBelow(AVSValue args, void* user_data, IScriptEnvironment* env);


class IsEqualTo : public SelectFilter 
{   
	double threshold;
	Number number;//(clip);
public:
	IsEqualTo(PClip _child, Number _number, double _threshold, IScriptEnvironment* env)
		: SelectFilter(_child, env), number(_number), threshold(_threshold){} 
	virtual SelectPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_IsEqualTo(AVSValue args, void* user_data, IScriptEnvironment* env);



class Minimum : public NumberFilter 
{   
	vector<Number> arguments;
public:
	Minimum(PClip _child, vector<Number> _arguments, IScriptEnvironment* env)
		: NumberFilter(_child, env), arguments(_arguments) {} 
	virtual NumberPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_Minimum(AVSValue args, void* user_data, IScriptEnvironment* env);

class Maximum : public NumberFilter 
{   
	vector<Number> arguments;
public:
	Maximum(PClip _child, vector<Number> _arguments, IScriptEnvironment* env)
		: NumberFilter(_child, env), arguments(_arguments) {} 
	virtual NumberPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_Maximum(AVSValue args, void* user_data, IScriptEnvironment* env);




class BlendAngle : public NumberFilter 
{   
	ComputeDistance distancecache;//(clip);
public:
	BlendAngle(PClip _child, IScriptEnvironment* env)
		: NumberFilter(_child, env), distancecache(_child) {} 
	virtual NumberPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_BlendAngle(AVSValue args, void* user_data, IScriptEnvironment* env);


class BlendWeight : public NumberFilter 
{   
	ComputeDistance distancecache;//(clip);
public:
	BlendWeight(PClip _child, IScriptEnvironment* env)
		: NumberFilter(_child, env), distancecache(_child) {} 
	virtual NumberPt GetPt(int n, IScriptEnvironment* env);
};
AVSValue __cdecl Create_BlendWeight(AVSValue args, void* user_data, IScriptEnvironment* env);



